package com.blamejared.compat.betterwithmods.base.blockrecipes;

import com.blamejared.mtlib.helpers.LogHelper;
import com.blamejared.mtlib.helpers.InputHelper;
import crafttweaker.api.item.IItemStack;
import betterwithmods.common.registry.block.managers.CraftingManagerBlock;
import net.minecraft.item.ItemStack;
import com.blamejared.mtlib.utils.BaseAction;
import betterwithmods.common.registry.block.recipe.BlockRecipe;

public class BlockRecipeRemoveInput<T extends BlockRecipe> extends BaseAction
{
    private final ItemStack input;
    private CraftingManagerBlock<T> manager;
    
    public BlockRecipeRemoveInput(final String name, final CraftingManagerBlock<T> manager, final IItemStack input) {
        this(name, manager, InputHelper.toStack(input));
    }
    
    private BlockRecipeRemoveInput(final String name, final CraftingManagerBlock<T> manager, final ItemStack input) {
        super(name);
        this.manager = manager;
        this.input = input;
    }
    
    public void apply() {
        if (!this.manager.removeByInput(this.input)) {
            LogHelper.logWarning(String.format("No recipes were removed for input %s", this.getRecipeInfo()));
        }
        else {
            LogHelper.logInfo(String.format("Successfully removed all recipes with %s as input", this.getRecipeInfo()));
        }
    }
    
    protected String getRecipeInfo() {
        return String.format("%s - %s", this.name, this.input.func_82833_r());
    }
}
